/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.fremdkandidatur.entity;

@javax.persistence.NamedQueries(
 {



   
      @javax.persistence.NamedQuery(
     name="FREMDKANDIDATUR.WahlAndOrdnungsmerkmal",
     query="SELECT obj FROM Fremdkandidatur obj WHERE obj.wahl = ?1 AND obj.externesOrdnungsmerkmal = ?2",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="FREMDKANDIDATUR.Wahl",
     query="SELECT obj FROM Fremdkandidatur obj WHERE obj.wahl=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "false"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "FREMDKANDIDATUR")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="personendaten_id")
@javax.persistence.DiscriminatorValue(Fremdkandidatur.DISCRIMINATOR_VALUE)

public
 class Fremdkandidatur
extends AbstractFremdkandidatur
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "FREMDKANDIDATUR";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Fremdkandidatur() {
    super();
  }
    public Fremdkandidatur(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Fremdkandidatur(Fremdkandidatur original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedDatumPruefung = false;
          hasChangedBescheinigungDokumentErstelltAm = false;
          hasChangedBescheinigungDokumentErstelltVon = false;
          hasChangedBescheinigungDokumentStatus = false;
  



    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Temporal(javax.persistence.TemporalType.DATE)
  @javax.persistence.Column(name = "DATUM_PRUEFUNG", nullable = FremdkandidaturConstants.DATUM_PRUEFUNG_NULLABLE, precision=FremdkandidaturConstants.DATUM_PRUEFUNG_PRECISION)
    
  protected java.util.Date datumPruefung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDatumPruefung = false;

  public boolean hasChangedDatumPruefung(){
    return hasChangedDatumPruefung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertDatumPruefung = false;
     @javax.persistence.Transient
     private transient java.util.Date wertNachLadenDatumPruefung;
  
  /**
   * 
   *
   * getter for FREMDKANDIDATUR.DATUM_PRUEFUNG
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getDatumPruefung() {
              if (datumPruefung == null){
            return null;
          } else {
                          return datumPruefung;
          }
      }

  /**
   * 
   *
   * setter for FREMDKANDIDATUR.DATUM_PRUEFUNG
   *
   * @param datumPruefung
   */
  @Override   public void setDatumPruefung(@javax.annotation.Nullable  java.util.Date datumPruefung) {

       resetTkCache();
                  java.util.Date datumPruefungInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDate(datumPruefung);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.datumPruefung
      , datumPruefungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDatumPruefung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("datumPruefung");
      }


             if (!isSeitLadenVeraendertDatumPruefung) {
          isSeitLadenVeraendertDatumPruefung = thisAttributChanged;
         if (isSeitLadenVeraendertDatumPruefung){
           wertNachLadenDatumPruefung=this.datumPruefung;
         }
       }
      

       this.datumPruefung = datumPruefungInternal;

         }

        
  @javax.persistence.Temporal(javax.persistence.TemporalType.TIMESTAMP)
  @javax.persistence.Column(name = "WAEHLBARKEIT_DOK_ERSTELLT_AM", nullable = FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_AM_NULLABLE, precision=FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_AM_PRECISION)
    
  protected java.util.Date bescheinigungDokumentErstelltAm =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBescheinigungDokumentErstelltAm = false;

  public boolean hasChangedBescheinigungDokumentErstelltAm(){
    return hasChangedBescheinigungDokumentErstelltAm;
  }
  
  /**
   * 
   *
   * getter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_ERSTELLT_AM
   */
  @javax.annotation.Nullable   @Override   public  java.util.Date getBescheinigungDokumentErstelltAm() {
              if (bescheinigungDokumentErstelltAm == null){
            return null;
          } else {
                          return bescheinigungDokumentErstelltAm;
          }
      }

  /**
   * 
   *
   * setter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_ERSTELLT_AM
   *
   * @param bescheinigungDokumentErstelltAm
   */
  @Override   public void setBescheinigungDokumentErstelltAm(@javax.annotation.Nullable  java.util.Date bescheinigungDokumentErstelltAm) {

       resetTkCache();
                  java.util.Date bescheinigungDokumentErstelltAmInternal = de.ivu.elect.jee.entity.EntityUtil.normalizeDateTime(bescheinigungDokumentErstelltAm);
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bescheinigungDokumentErstelltAm
      , bescheinigungDokumentErstelltAmInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBescheinigungDokumentErstelltAm |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bescheinigungDokumentErstelltAm");
      }


      

       this.bescheinigungDokumentErstelltAm = bescheinigungDokumentErstelltAmInternal;

         }

        
  @javax.persistence.Column(name = "WAEHLBARKEIT_DOK_ERSTELLT_VON", nullable = FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_VON_NULLABLE, length=FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_VON_MAX_LENGTH)
        
  protected java.lang.String bescheinigungDokumentErstelltVon =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBescheinigungDokumentErstelltVon = false;

  public boolean hasChangedBescheinigungDokumentErstelltVon(){
    return hasChangedBescheinigungDokumentErstelltVon;
  }
  
  /**
   * 
   *
   * getter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_ERSTELLT_VON
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBescheinigungDokumentErstelltVon() {
        return bescheinigungDokumentErstelltVon;
      }

  /**
   * 
   *
   * setter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_ERSTELLT_VON
   *
   * @param bescheinigungDokumentErstelltVon
   */
  @Override   public void setBescheinigungDokumentErstelltVon(@javax.annotation.Nullable  java.lang.String bescheinigungDokumentErstelltVon) {

       resetTkCache();
                  
                          java.lang.String bescheinigungDokumentErstelltVonInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bescheinigungDokumentErstelltVon, FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_VON_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bescheinigungDokumentErstelltVon
      , bescheinigungDokumentErstelltVonInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBescheinigungDokumentErstelltVon |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bescheinigungDokumentErstelltVon");
      }


      

       this.bescheinigungDokumentErstelltVon = bescheinigungDokumentErstelltVonInternal;

         }

        
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "WAEHLBARKEIT_DOK_STATUS", nullable = FremdkandidaturConstants.WAEHLBARKEIT_DOK_STATUS_NULLABLE)
    
  protected de.ivu.elect.business.fremdkandidatur.entity.BescheinigungDokumentStatus bescheinigungDokumentStatus =  de.ivu.elect.business.fremdkandidatur.entity.BescheinigungDokumentStatus.ZU_ERSTELLEN;

  @javax.persistence.Transient
  protected boolean hasChangedBescheinigungDokumentStatus = false;

  public boolean hasChangedBescheinigungDokumentStatus(){
    return hasChangedBescheinigungDokumentStatus;
  }
  
  /**
   * 
   *
   * getter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_STATUS
   */
    @Override   public  de.ivu.elect.business.fremdkandidatur.entity.BescheinigungDokumentStatus getBescheinigungDokumentStatus() {
        return bescheinigungDokumentStatus;
      }

  /**
   * 
   *
   * setter for FREMDKANDIDATUR.WAEHLBARKEIT_DOK_STATUS
   *
   * @param bescheinigungDokumentStatus
   */
  @Override   public void setBescheinigungDokumentStatus( de.ivu.elect.business.fremdkandidatur.entity.BescheinigungDokumentStatus bescheinigungDokumentStatus) {

       resetTkCache();
                  de.ivu.elect.business.fremdkandidatur.entity.BescheinigungDokumentStatus bescheinigungDokumentStatusInternal = bescheinigungDokumentStatus;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bescheinigungDokumentStatus
      , bescheinigungDokumentStatusInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBescheinigungDokumentStatus |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bescheinigungDokumentStatus");
      }


      

       this.bescheinigungDokumentStatus = bescheinigungDokumentStatusInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Fremdkandidatur:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Fremdkandidatur other){
        super.copyEntity(other);
                             other.datumPruefung = this.datumPruefung;
                                other.bescheinigungDokumentErstelltAm = this.bescheinigungDokumentErstelltAm;
                                other.bescheinigungDokumentErstelltVon = this.bescheinigungDokumentErstelltVon;
                                other.bescheinigungDokumentStatus = this.bescheinigungDokumentStatus;
           
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Fremdkandidatur.class)){
        copyEntityAttributesUsingSetter((Fremdkandidatur) other.castTo(Fremdkandidatur.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Fremdkandidatur: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Fremdkandidatur other){
      super.copyEntityAttributesUsingSetter(other);
               other.setDatumPruefung(this.datumPruefung);
                  other.setBescheinigungDokumentErstelltAm(this.bescheinigungDokumentErstelltAm);
                  other.setBescheinigungDokumentErstelltVon(this.bescheinigungDokumentErstelltVon);
                  other.setBescheinigungDokumentStatus(this.bescheinigungDokumentStatus);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
       if (other.isInstanceOf(Fremdkandidatur.class)) {
         copyEntityAttributesUsingSetter(other.castTo(Fremdkandidatur.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Fremdkandidatur other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedDatumPruefung) {
        other.setDatumPruefung(this.datumPruefung);
      }
                             if (hasChangedBescheinigungDokumentErstelltAm) {
        other.setBescheinigungDokumentErstelltAm(this.bescheinigungDokumentErstelltAm);
      }
                             if (hasChangedBescheinigungDokumentErstelltVon) {
        other.setBescheinigungDokumentErstelltVon(this.bescheinigungDokumentErstelltVon);
      }
                             if (hasChangedBescheinigungDokumentStatus) {
        other.setBescheinigungDokumentStatus(this.bescheinigungDokumentStatus);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.person.entity.Personendaten other){
      if (other.isInstanceOf(Fremdkandidatur.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(Fremdkandidatur.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient FremdkandidaturTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public FremdkandidaturTK getFremdkandidaturTK(){
    if (tkCache==null) {
    tkCache = new FremdkandidaturTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getFremdkandidaturTK();
    }

  @Override
  public FremdkandidaturUK getUk(){
    return getFremdkandidaturUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Fremdkandidatur.class;
  }

public FremdkandidaturUK getFremdkandidaturUK(){

   return  new FremdkandidaturUK(



  );
}

  @javax.persistence.Transient
  private transient FremdkandidaturProperties properties;

  @Override
  public FremdkandidaturProperties getProperties(){
    if (properties == null) {
      properties = new FremdkandidaturProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public FremdkandidaturProperties getFremdkandidaturProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return FremdkandidaturConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
     
      if (werteVorher.containsKey(FremdkandidaturConstants.MESSAGE_KEY_DATUM_PRUEFUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(FremdkandidaturConstants.MESSAGE_KEY_DATUM_PRUEFUNG_EINZAHL);

        datumPruefung =
     vorher.getAttributTyp().getValueAsDate(vorher.getWertVorher());
          }

                                        }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                        if (isSeitLadenVeraendertDatumPruefung) {
      result.put(FremdkandidaturConstants.MESSAGE_KEY_DATUM_PRUEFUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.DATE
                , wertNachLadenDatumPruefung , datumPruefung));
    }
                                                                            return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                      isSeitLadenVeraendertDatumPruefung = false;
      wertNachLadenDatumPruefung = null;
                                                                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
            return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "FREMDKANDIDATUR";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                                                                                                                                                                             de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(FremdkandidaturConstants.WAEHLBARKEIT_DOK_ERSTELLT_VON_MAX_LENGTH ,  bescheinigungDokumentErstelltVon, this, FremdkandidaturConstants.MESSAGE_KEY_WAEHLBARKEIT_DOK_ERSTELLT_VON_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(bescheinigungDokumentStatus, this, FremdkandidaturConstants.MESSAGE_KEY_WAEHLBARKEIT_DOK_STATUS_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            }
